#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QColorDialog>
#include <QListWidgetItem>
#include <QTime>
#include <vector>
#include "../actors/alarmtime.h"
#include "../microcontroller.h"
#include "../sensors/sensor.h"
#include "../items/itemstore.h"
#include "../items/poweritem.h"


namespace Ui
{
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(Microcontroller *micro, PowerItem* powerItem, ItemStore* itemStore, SensorStore *sensorStore, QWidget *parent = nullptr);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    QColorDialog colorChooser;

    Microcontroller *_micro;

    PowerItem *_powerItem;

private slots:

    //RGB
    void slotChangedRgb(const QColor color);
    void showPowerItemDialog();

public slots:

    void changeHeaderLableText(QString string);
};

#endif // MAINWINDOW_H
